//Body Swap Script, also a fetish of Badspot

if(isFile("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	}
	
	RTB_registerPref("Request Duration", "Body Swap", "$BD::RequestDuration", "int 0 600", "Server_BDSwap", 60, 0, 0);
	RTB_registerPref("Time Between Requests", "Body Swap", "$BD::Cooldown", "int 0 600", "Server_BDSwap", 60, 0, 0);
}

else
{
	$BD::RequestDuration = 60000;
	$BD::Cooldown = 60;
}

package swapConnectionCleaning
{
	function GameConnection::OnClientLeaveGame(%user)
	{
		Parent::OnClientLeaveGame(%user);
		
		if(%user.swapInfoSent !$= "")
		{
			%client = %user.swapInfoSent;
			
			for(%a = 0; %a != 100; %a++)
			{
				if(%client.swapInfoStorage[%a] == %user)
				{
					%client.swapInfoStorage[%a] = "";
					%a = 99;
				}
			}
			
			%user.swapInfoSent = "";
		}
		
		for(%a = 0; %a != 100; %a++)
		{
			if(%user.swapInfoStorage[%a] !$= "")
			{
				%user.swapInfoStorage[%a].swapInfoSent = "";
				%user.swapInfoStorage[%a] = "";
			}
		}
	}
};
activatePackage("swapConnectionCleaning");

function serverCmdBd (%client, %cmd, %user, %pon)
{
	if(%cmd $= "swap")
	{
		if($sim::time - %client.lastRequest < $BD::Cooldown)
		{
			%timeleft = mCeil($BD::Cooldown - ($sim::time - %client.lastRequest));
			messageClient(%client,"","\c6You cannot swap for another \c3" @ %timeleft @ "\c6 seconds.");
			return;
		}
		
		if(%user $= "")
		{
			messageClient(%client,"","\c6Please specify who you would like to swap with.");
			return;
		}
	
		%user = findClientByName(%user);
	
		if(%user $= %client)
		{
			messageClient(%client,"","\c6You cannot swap with yourself, no matter how handsome you look.");
			return;
		}
		
		if(!isObject(%user))
		{
			messageClient(%client,"","\c6Player does not exist.");
			return;
		}
	
		if(%client.swapInfoSent !$= "")
		{
			messageClient(%client,"","\c6You have already sent a swap request to a player.");
			return;
		}

		if(%user.swapInfoSent $= %client)
		{
			messageClient(%client,"","\c6This person has already sent a request to you.");
			return;
		}
	
		if(%client.miniGame || %user.miniGame)
		{
			if(%client.miniGame != %user.miniGame)
			{
				messageClient(%client,"","\c6You have to be in the same minigame to swap.");
				return;
			}
		}

		if(%client.player.getDataBlock().maxtools != %user.player.getDataBlock().maxtools)
		{
			messageClient(%client,"","\c6Your amount of inventory slots must be the same as\c3" SPC %user.name @ "\c6's to be able to swap.");
			return;
		}
	
		for(%a = 0; %a != 100; %a++)
		{
			if(%user.swapInfoStorage[%a] $= "")
			{
				%user.swapInfoStorage[%a] = %client;
				%client.swapInfoSent = %user;
				%a = 99;
			}
		}

		messageClient(%client,"","\c6You have sent a request to\c3" SPC %user.name @ "\c6.");
		messageClient(%user,"","\c3" @ %client.name SPC "\c6has sent you a request.");
		
		%client.lastRequest = $sim::time;
		
		schedule($BD::RequestDuration*1000, 0, serverCmdBd, %client, "cancel", %user.name, true);
	}
	
	
	if(%cmd $= "accept")
	{
		if(%user $= "")
		{
			messageClient(%client,"","\c6Please specify who you would like to swap with.");
			return;
		}
	
		%user = findClientByName(%user);
	
		if(!isObject(%user))
		{
			messageClient(%client,"","\c6Player does not exist.");
			return;
		}
		
		if(%user.swapInfoSent != %client)
		{
			messageClient(%client,"","\c6No request from this person exists.");
			return;
		}
	
		if(!isObject(%user.player))
		{
			messageClient(%client,"","\c6The player you are trying to swap with is currently dead, please try again when they respawn.");
			return;
		}
	
		if(!isObject(%client.player))
		{
			messageClient(%client,"","\c6You cannot swap while you are dead.");
			return;
		}
	
		if(isObject(%client.miniGame) || isObject(%user.miniGame))
		{
			if(%client.miniGame != %user.miniGame)
			{
				messageClient(%client,"","\c6You have to be in the same minigame to swap.");
				return;
			}
		}
	
		if(%client.getControlObject().getDatablock() == 12 || %user.getControlObject().getDatablock() == 12)
		{
			messageClient(%client,"","\c6You must both be in your player before you swap.");
			return;
		}
		
		if(%client.player.getDataBlock().maxtools != %user.player.getDataBlock().maxtools)
		{
			messageClient(%client,"","\c6Your amount of inventory slots must be the same as\c3" SPC %user.name @ "\c6's to be able to swap.");
			return;
		}
	
		for(%bdMaxTools = 0; %bdMaxTools < %user.player.getDatablock().maxTools; %bdMaxTools++)
		{
			%bdHolder[%client, %bdMaxTools] = %client.player.tool[%bdMaxTools];
			%bdHolder[%user, %bdMaxTools] = %user.player.tool[%bdMaxTools];
		}
	
		%user.setcontrolobject(%client.player);
		%client.setcontrolobject(%user.player);
        
		%user.player = %user.getcontrolobject();
		%client.player = %client.getcontrolobject();
		
		%user.player.client = %user;
		%client.player.client = %client;
	
		for(%bdMaxTools = 0; %bdMaxTools < %client.player.getDatablock().maxTools; %bdMaxTools++)
		{
			%client.player.tool[%bdMaxTools] = %bdHolder[%user, %bdMaxTools];
			messageClient(%client, 'MsgItemPickup', "", %bdMaxTools, %bdHolder[%user, %bdMaxTools]);
		
			%user.player.tool[%bdMaxTools] = %bdHolder[%client, %bdMaxTools];
			messageClient(%user, 'MsgItemPickup', "", %bdMaxTools, %bdHolder[%client, %bdMaxTools]);
		}
	
		for(%a = 0; %a != 100; %a++)
		{
			if(%client.swapInfoStorage[%a] $= %user)
			{
				%client.swapInfoStorage[%a] = "";
				%user.swapInfoSent = "";
				%a = 99;
			}
		}
		
		messageClient(%client,"","\c6You have accepted\c3" SPC %user.name @ "\c6's request.");
		messageClient(%user,"","\c3" @ %client.name SPC "\c6has accepted your request.");
	}
	
	
	if(%cmd $= "decline")
	{
		if(%user $= "")
		{
			messageClient(%client,"","\c6Please specify who you would like to decline.");
			return;
		}
	
		%user = findClientByName(%user);

		if(!isObject(%user))
		{
			messageClient(%client,"","\c6Player does not exist.");
			return;
		}
	
		if(%user.swapInfoSent != %client)
		{
			messageClient(%client,"","\c6No request from this person exists.");
			return;
		}
	
		for(%a = 0; %a != 100; %a++)
		{
			if(%client.swapInfoStorage[%a] == %user)
			{
				%client.swapInfoStorage[%a] = "";
				%user.swapInfoSent = "";
				%a = 99;
			}
		}
		
		messageClient(%client,"","\c6You have declined\c3" SPC %user @ "\c6's request.");
		messageClient(%user,"","\c3" @ %client SPC "\c6has declined your request.");
	}
	
	
	if(%cmd $= "cancel")
	{
		if(%user $= "")
		{
			messageClient(%client,"","\c6Please specify whose request you would like to cancel.");
			return;
		}
	
		%user = findClientByName(%user);

		if(!isObject(%user))
		{
			messageClient(%client,"","\c6Player does not exist.");
			return;
		}
	
		if(%client.swapInfoSent != %user)
		{
			messageClient(%client,"","\c6You have not sent a request to this person.");
			return;
		}
	
		for(%a = 0; %a != 100; %a++)
		{
			if(%user.swapInfoStorage[%a] == %client)
			{
				%user.swapInfoStorage[%a] = "";
				%client.swapInfoSent = "";
				%a = 99;
			}
		}
		
		if(%pon == true)
		{
			return;
		}
		
		messageClient(%client,"","\c6You have canceled your request to\c3" SPC %user.name @ "\c6.");
		messageClient(%user,"","\c3" @ %client.name SPC "\c6has canceled his request to you.");
	}
	
	
	if(%cmd $= "list")
	{
		messageClient(%client,"","\c6Requests received:");
		
		for(%a = 0; %a != 100; %a++)
		{
			if(%client.swapInfoStorage[%a] !$= "")
			{
				messageClient(%client,"","\c3" @ %client.swapInfoStorage[%a].name @ "");
				%b++;
			}
		}
		
		if(%b == 0)
		{
			messageClient(%client,"","\c6None");
		}
	}
	
	if(%cmd $= "help")
	{
		messageClient(%client,"","\c6Commands:");
		messageClient(%client,"","\c3/bd swap [\c6name\c3] \c6- This command lets you send a request to swap bodies with a player.");
		messageClient(%client,"","\c3/bd accept [\c6name\c3] \c6- This command lets you accept a request to swap bodies with a player.");
		messageClient(%client,"","\c3/bd decline [\c6name\c3] \c6- This command lets you decline a request to swap bodies with a player.");
		messageClient(%client,"","\c3/bd cancel [\c6name\c3] \c6- This command lets you cancel a request you sent to swap bodies with a player.");
		messageClient(%client,"","\c3/bd list \c6- This command shows you a list of active requests sent to you.");
		messageClient(%client,"","\c3/bd help \c6- This command shows this information.");
	}
}